using .JLD2

# InPartS IO Backend API
dfopen(type::Type{JLD2.JLDFile}, filename::String, mode::String = "r") = JLD2.jldopen(filename, mode)

dfclose(f::JLD2.JLDFile) = close(f)
function dfrename(::Type{JLD2.JLDFile}, oldname, newname; force = false)
    cp(oldname, newname; force = force)
    rm(oldname)
end

gcreate(g::Union{JLD2.JLDFile, JLD2.Group}, name::String; kwargs...) = JLD2.Group(g, name; kwargs...)

isgroup(g::Union{JLD2.JLDFile, JLD2.Group}, key) = (g[key] isa JLD2.Group)
Base.length(g::Union{JLD2.JLDFile, JLD2.Group}) = length(keys(g))

# For backwards compatibility with HDF5 write all SArrays as Arrays
Base.setindex!(g::JLD2.Group, value::SArray, key::String) = setindex!(g, collect(value), key)
Base.setindex!(g::JLD2.JLDFile, value::SArray, key::String) = setindex!(g, collect(value), key)
Base.setindex!(g::JLD2.Group, value::Dict{String, Any}, key::String) = InPartS.writedict(g, value; name = key)
Base.setindex!(g::JLD2.JLDFile, value::Dict{String, Any}, key::String) = InPartS.writedict(g, value; name = key)



# more efficient readdict
readdict(g::Union{JLD2.JLDFile, JLD2.Group}; kwargs...) = JLD2.loadtodict!(Dict{String,Any}(), g)
readdict(d::Dict) = d
